#include "STM32.h"
#include "SButton.h"
#include "HX8347_8bit.h"
#include "IO_Digital.h"

#define DATA_PORT   GPIOA
#define DATA_PINS   GPIO_PIN_0
#define RESET_PORT  GPIOB
#define RESET_PIN   GPIO_PIN_12
#define CS_PORT     GPIOB
#define CS_PIN      GPIO_PIN_0
#define RS_PORT     GPIOB
#define RS_PIN      GPIO_PIN_1
#define WR_PORT     GPIOB
#define WR_PIN      GPIO_PIN_13
#define RD_PORT     GPIOB
#define RD_PIN      GPIO_PIN_14

HX8347  myTFT;
IO_Digital  Led_01(GPIOC, GPIO_PIN_13, Output, No_Pull);

int main(void)
{
  FLASH_DATAEEPROM_Unlock();
  SystemClock_Config(Quartz_None);
  myTFT.Init(DATA_PORT, DATA_PINS, RESET_PORT, RESET_PIN, CS_PORT, CS_PIN, RS_PORT, RS_PIN, WR_PORT, WR_PIN, RD_PORT, RD_PIN);
  myTFT.setRotation(1);
  myTFT.fillScreen(COLOR_BLUE);
  myTFT.setTextColor(COLOR_WHITE, COLOR_BLACK);
  myTFT.setTextSize(2);
  myTFT.println("Hello\n\r");
  myTFT.fillCircle(120, 120, 50, COLOR_YELLOW);
  myTFT.fillRect(20, 20, 100, 100, COLOR_GREEN);

  while (1)
  {
    Led_01.digitalTogglePin();
    delay(1000);
  }
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

