/*
 * EEPROM.cpp
 *
 *  Created on: 27 авг. 2021 г.
 *      Author: User
 */

//****************************************************************************** 
//  Секция include: здесь подключается заголовочный файл к модулю 
//****************************************************************************** 
#include  "EEPROM.h"      // Включаем файл заголовка для нашего модуля 




//****************************************************************************** 
//  Секция определения переменных, используемых в модуле 
//****************************************************************************** 

//------------------------------------------------------------------------------ 
// Глобальные  
//------------------------------------------------------------------------------ 

//char GlobalVar1; 
//char GlobalVar2; 

//------------------------------------------------------------------------------ 
// Локальные 
//------------------------------------------------------------------------------ 
//static char LocalVar1; 
//static char LocalVar2; 

//****************************************************************************** 
//  Секция прототипов локальных функций 
//****************************************************************************** 
//void local_func1 (void); 
//void local_func2 (void); 

//****************************************************************************** 
//  Секция описания глобальных функций
//****************************************************************************** 
bool FLASH_DATAEEPROM_Unlock(void)
{
  uint32_t primask_bit;

  if((FLASH->PECR & FLASH_PECR_PELOCK) != 0)
  {
    /* Disable interrupts to avoid any interruption during unlock sequence */
    primask_bit = __get_PRIMASK();
    __disable_irq();

    /* Unlocking the Data memory and FLASH_PECR register access*/
    FLASH->PEKEYR = FLASH_PEKEY1;
    FLASH->PEKEYR = FLASH_PEKEY2;

    /* Re-enable the interrupts: restore previous priority mask */
    __set_PRIMASK(primask_bit);

    if((FLASH->PECR & FLASH_PECR_PELOCK) != 0)
    {
      return 1;
    }
  }

  return 0;
}

//****************************************************************************** 
//  Секция описания локальных функций
//****************************************************************************** 
//void local_func1 (void) 
//{ 
//    ...; 
//} 

//****************************************************************************** 
//  ENF OF FILE 
//****************************************************************************** 

